//Bobby McDonald
//CS15
//2/01/01
//original author:  Carol Conway
//file QuadSolverwithInputOutputFiles.cpp
//Program solves the quadratic equation: a*x*x + b * x + c = 0
//It reads coefs. of the equation from an input file
//and writes results to an output file
//Runtime and Logic errors are corrected in this updated version

#include <iomanip>		//for formatting
#include <cmath>		//for square roots
#include <fstream>		//for text files
#include <iostream>		//for interactive IO
#include <cstdlib>		//for use of the exit() function
using namespace std;	//enables use of ANSI C++ libraries above

int equation(float, float, float, float&, float&);  //function to calculate roots
void incoef(ifstream&, float&, float&, float&);		//input and output to file functions
void output(ofstream&, float, float, float, float&, float&, int&);
int main()
{
	float a, b, c;			//coefficients of the equation
	float root1, root2;		//the answers
	ifstream infile("Coef.txt");     //input file variable
	ofstream outfile;		//output file variable
					//the input and output files are located in the same directory as the source
	if (!infile)
	{
		cout << "Exiting!  Error opening file.  Does it exist?\n";
		exit(0);
	}

	outfile.open("QuadOut.txt");				//output filename
	outfile.setf(ios::fixed, ios::floatfield);	//also for file
	outfile.setf(ios::showpoint);
	outfile.precision(2);                       //sets decimal places to 2
	outfile << "QUADRATIC EQUATION	           A	  " << "    B           C " << endl; 

	while (!infile.eof())						//says to go until it reaches "end of file"
	{	
		
		incoef(infile, a, b, c);			//function that inputs a, b & c
		equation (a, b, c, root1, root2);	//funtion that computes roots
		int retvalue = equation (a, b, c, root1, root2); 
		output(outfile, a, b, c, root1, root2, retvalue);
		cout<<"return value is "<<equation(a, b, c, root1, root2)<<endl; 
											//output function that writes to the file "QuadOut.txt"
	}		
	return 0;
}

void incoef(ifstream& infile, float& a, float& b, float& c)
{
		infile  >>  a;		//taking in a, b, & c from coef.txt
		infile  >>  b;
		infile  >>  c;
}

int equation(float a, float b, float c, float& root1, float& root2)
{	
	int retvalue;
	float discr = (b * b) - (4 * a * c);
	int finished = 1;
	if(discr < 0)		 //you can't get the sqrt of a negative
	{	
		retvalue=0;
		finished=2; 
	}
	if(discr == b)		 //0 can't be divided, 0 is the only answer
	{
		retvalue=1;
		finished=2;
	}
	if(discr == -b)		
	{
		retvalue=1;
		finished=2;
	}
	if(0 == a)			 //linear equation
	{	
		retvalue=2; 
		finished=2;	
	}
	
	if (finished == 1)	  //shows that none of the if statements were reached
	{
		root1 = (-b + (sqrt(discr))) / (2 * a);  //calculates the roots
		root2 = (-b - (sqrt(discr))) / (2 * a);
		if (root1 == root2) retvalue =4;		 //checks if there's only 1 solution
		else retvalue = 3;						
	}	
	return retvalue;							 //returns retvalue to the other function
}

void output(ofstream& outfile, float a, float b, float c, float& root1, float& root2, int& retvalue)
{
		outfile<<"Solves quadratic equation with   a = " << a << "   b = " << b 
															<<  "   c = " << c << endl; 
		if (retvalue == 0) outfile<<"No real roots: can't get sqrt of a negative number \n"<<endl;
		if (retvalue == 1) outfile<<"The only solution to this problem is 0 \n"<<endl;
		if (retvalue == 2) outfile<<"This is a linear equation, you don't need the Quadratic \n \n";
		if (retvalue == 4) outfile<<"This problem only has one solution:   "<<root1<<endl<<endl;
		if (retvalue == 3) 
		{
		outfile << "Root 1 is " << root1;						//prints to file
		outfile << " and Root 2 is " << root2 << endl <<endl;
		}
}	